diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/tid-to-link-mapping-element.h ns-3.44/src/wifi/model/eht/tid-to-link-mapping-element.h
--- ns-3.43/src/wifi/model/eht/tid-to-link-mapping-element.h	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/eht/tid-to-link-mapping-element.h	2025-03-09 16:55:49.787372600 -0700
@@ -31,8 +31,8 @@
 constexpr uint16_t WIFI_LINK_MAPPING_PRESENCE_IND_SIZE_B = 1;
 
 /**
- * \brief TID-to-Link Mapping Information Element
- * \ingroup wifi
+ * @brief TID-to-Link Mapping Information Element
+ * @ingroup wifi
  *
  * This class serializes and deserializes
  * the TID-to-Link Mapping element
@@ -53,20 +53,20 @@
         WifiDirection direction{DEFAULT_WIFI_TID_LINK_MAP_DIR}; ///< Direction
         bool defaultMapping{DEFAULT_WIFI_TID_LINK_MAPPING};     ///< Default link mapping
 
-        /// \return Serialized size of TID-to-Link Mapping Control in octets
+        /// @return Serialized size of TID-to-Link Mapping Control in octets
         uint16_t GetSubfieldSize() const;
 
         /**
          * Serialize the TID-to-Link Mapping Control subfield
          *
-         * \param start iterator pointing to where the subfield should be written to
+         * @param start iterator pointing to where the subfield should be written to
          */
         void Serialize(Buffer::Iterator& start) const;
         /**
          * Deserialize the TID-to-Link Mapping Control subfield
          *
-         * \param start iterator pointing to where the subfield should be read from
-         * \return the number of octets read
+         * @param start iterator pointing to where the subfield should be read from
+         * @return the number of octets read
          */
         uint16_t Deserialize(Buffer::Iterator start);
 
@@ -87,38 +87,38 @@
     /**
      * Set the Mapping Switch Time field.
      *
-     * \param mappingSwitchTime the time when the new mapping is established (rounded to a
+     * @param mappingSwitchTime the time when the new mapping is established (rounded to a
      *                          multiple of a TU)
      */
     void SetMappingSwitchTime(Time mappingSwitchTime);
 
-    /// \return the value of the Mapping Switch Time field, if present.
+    /// @return the value of the Mapping Switch Time field, if present.
     std::optional<Time> GetMappingSwitchTime() const;
 
     /**
      * Set the Expected Duration field.
      *
-     * \param expectedDuration the value for the Expected Duration field (rounded to a
+     * @param expectedDuration the value for the Expected Duration field (rounded to a
      *                         multiple of a TU)
      */
     void SetExpectedDuration(Time expectedDuration);
 
-    /// \return the value of the Expected Duration field, if present.
+    /// @return the value of the Expected Duration field, if present.
     std::optional<Time> GetExpectedDuration() const;
 
     /**
      * Set the Link Mapping field of the given TID such that the given TID is mapped
      * to the links associated with the given link IDs.
      *
-     * \param tid the given TID
-     * \param linkIds the IDs of the links which the given TID is mapped to
+     * @param tid the given TID
+     * @param linkIds the IDs of the links which the given TID is mapped to
      */
     void SetLinkMappingOfTid(uint8_t tid, std::set<uint8_t> linkIds);
     /**
      * Get the Link Mapping field of the given TID.
      *
-     * \param tid the given TID
-     * \return the IDs of the links which the given TID is mapped to
+     * @param tid the given TID
+     * @return the IDs of the links which the given TID is mapped to
      */
     std::set<uint8_t> GetLinkMappingOfTid(uint8_t tid) const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/error-rate-model.cc ns-3.44/src/wifi/model/error-rate-model.cc
--- ns-3.43/src/wifi/model/error-rate-model.cc	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/error-rate-model.cc	2025-03-09 16:55:49.787372600 -0700
@@ -62,7 +62,7 @@
     if (mode.GetModulationClass() == WIFI_MOD_CLASS_DSSS ||
         mode.GetModulationClass() == WIFI_MOD_CLASS_HR_DSSS)
     {
-        switch (mode.GetDataRate(22))
+        switch (mode.GetDataRate(MHz_u{22}))
         {
         case 1000000:
             return DsssErrorRateModel::GetDsssDbpskSuccessRate(snr, nbits);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/error-rate-model.h ns-3.44/src/wifi/model/error-rate-model.h
--- ns-3.43/src/wifi/model/error-rate-model.h	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/error-rate-model.h	2025-03-09 16:55:49.787372600 -0700
@@ -17,29 +17,29 @@
 {
 
 /**
- * \ingroup wifi
- * \brief the interface for Wifi's error models
+ * @ingroup wifi
+ * @brief the interface for Wifi's error models
  *
  */
 class ErrorRateModel : public Object
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
     /**
-     * \param txVector a specific transmission vector including WifiMode
-     * \param ber a target BER
+     * @param txVector a specific transmission vector including WifiMode
+     * @param ber a target BER
      *
-     * \return the SNR which corresponds to the requested BER
+     * @return the SNR which corresponds to the requested BER
      */
     double CalculateSnr(const WifiTxVector& txVector, double ber) const;
 
     /**
-     * \return true if the model is for AWGN channels,
+     * @return true if the model is for AWGN channels,
      *         false otherwise
      */
     virtual bool IsAwgn() const;
@@ -62,16 +62,16 @@
      * This method handles 802.11b rates by using the DSSS error rate model.
      * For all other rates, the method implemented by the subclass is called.
      *
-     * \param mode the Wi-Fi mode applicable to this chunk
-     * \param txVector TXVECTOR of the overall transmission
-     * \param snr the SNR of the chunk
-     * \param nbits the number of bits in this chunk
-     * \param numRxAntennas the number of active RX antennas (1 if not provided)
-     * \param field the PPDU field to which the chunk belongs to (assumes this is for the payload
+     * @param mode the Wi-Fi mode applicable to this chunk
+     * @param txVector TXVECTOR of the overall transmission
+     * @param snr the SNR of the chunk
+     * @param nbits the number of bits in this chunk
+     * @param numRxAntennas the number of active RX antennas (1 if not provided)
+     * @param field the PPDU field to which the chunk belongs to (assumes this is for the payload
      * part if not provided)
-     * \param staId the station ID for MU
+     * @param staId the station ID for MU
      *
-     * \return probability of successfully receiving the chunk
+     * @return probability of successfully receiving the chunk
      */
     double GetChunkSuccessRate(WifiMode mode,
                                const WifiTxVector& txVector,
@@ -86,8 +86,8 @@
      * used by this model. Return the number of streams (possibly zero) that
      * have been assigned.
      *
-     * \param stream first stream index to use
-     * \return the number of stream indices assigned by this model
+     * @param stream first stream index to use
+     * @return the number of stream indices assigned by this model
      */
     virtual int64_t AssignStreams(int64_t stream);
 
@@ -95,15 +95,15 @@
     /**
      * A pure virtual method that must be implemented in the subclass.
      *
-     * \param mode the Wi-Fi mode applicable to this chunk
-     * \param txVector TXVECTOR of the overall transmission
-     * \param snr the SNR of the chunk
-     * \param nbits the number of bits in this chunk
-     * \param numRxAntennas the number of active RX antennas
-     * \param field the PPDU field to which the chunk belongs to
-     * \param staId the station ID for MU
+     * @param mode the Wi-Fi mode applicable to this chunk
+     * @param txVector TXVECTOR of the overall transmission
+     * @param snr the SNR of the chunk
+     * @param nbits the number of bits in this chunk
+     * @param numRxAntennas the number of active RX antennas
+     * @param field the PPDU field to which the chunk belongs to
+     * @param staId the station ID for MU
      *
-     * \return probability of successfully receiving the chunk
+     * @return probability of successfully receiving the chunk
      */
     virtual double DoGetChunkSuccessRate(WifiMode mode,
                                          const WifiTxVector& txVector,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/extended-capabilities.cc ns-3.44/src/wifi/model/extended-capabilities.cc
--- ns-3.43/src/wifi/model/extended-capabilities.cc	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/extended-capabilities.cc	2025-03-09 16:55:49.787372600 -0700
@@ -11,67 +11,6 @@
 namespace ns3
 {
 
-ExtendedCapabilities::ExtendedCapabilities()
-    : m_20_40_bssCoexistenceManagementSupport(0),
-      m_extendedChannelSwitching(0),
-      m_psmpCapability(0),
-      m_spsmpSupport(0),
-      m_event(0),
-      m_diagnostics(0),
-      m_multicastDiagnostics(0),
-      m_locationTracking(0),
-      m_fms(0),
-      m_proxyArpService(0),
-      m_collocatedInterferenceReporting(0),
-      m_civicLocation(0),
-      m_geospatialLocation(0),
-      m_tfs(0),
-      m_wnmSleepMode(0),
-      m_timBroadcast(0),
-      m_bssTransition(0),
-      m_qosTrafficCapability(0),
-      m_acStationCount(0),
-      m_multipleBssid(0),
-      m_timingMeasurement(0),
-      m_channelUsage(0),
-      m_ssidList(0),
-      m_dms(0),
-      m_utcTsfOffset(0),
-      m_tpuBufferStaSupport(0),
-      m_tdlsPeerPsmSupport(0),
-      m_tdlsChannelSwitching(0),
-      m_interworking(0),
-      m_qosMap(0),
-      m_ebr(0),
-      m_sspnInterface(0),
-      m_msgcfCapability(0),
-      m_tdlsSupport(0),
-      m_tdlsProhibited(0),
-      m_tdlsChannelSwitchingProhibited(0),
-      m_rejectUnadmittedFrame(0),
-      m_serviceIntervalGranularity(0),
-      m_identifierLocation(0),
-      m_uapsdCoexistence(0),
-      m_wnmNotification(0),
-      m_qabCapability(0),
-      m_utf8Ssid(0),
-      m_qmfActivated(0),
-      m_qmfReconfigurationActivated(0),
-      m_robustAvStreaming(0),
-      m_advancedGcr(0),
-      m_meshGcr(0),
-      m_scs(0),
-      m_qloadReport(0),
-      m_alternateEdca(0),
-      m_unprotectedTxopNegotiation(0),
-      m_protectedTxopNegotiation(0),
-      m_protectedQloadReport(0),
-      m_tdlsWiderBandwidth(0),
-      m_operatingModeNotification(0),
-      m_maxNumberOfMsdusInAmsdu(0)
-{
-}
-
 WifiInformationElementId
 ExtendedCapabilities::ElementId() const
 {
@@ -81,7 +20,8 @@
 void
 ExtendedCapabilities::Print(std::ostream& os) const
 {
-    os << "Extended Capabilities=" << +GetExtendedCapabilitiesByte1();
+    os << "Extended Capabilities=";
+    // TODO: print useful capabilities
 }
 
 uint16_t
@@ -91,249 +31,168 @@
 }
 
 void
-ExtendedCapabilities::SetExtendedCapabilitiesByte1(uint8_t ctrl)
-{
-    m_20_40_bssCoexistenceManagementSupport = ctrl & 0x01;
-    m_extendedChannelSwitching = (ctrl >> 2) & 0x01;
-    m_psmpCapability = (ctrl >> 4) & 0x01;
-    m_spsmpSupport = (ctrl >> 6) & 0x01;
-    m_event = (ctrl >> 7) & 0x01;
-}
-
-uint8_t
-ExtendedCapabilities::GetExtendedCapabilitiesByte1() const
-{
-    uint8_t val = 0;
-    val |= m_20_40_bssCoexistenceManagementSupport & 0x01;
-    val |= (m_extendedChannelSwitching & 0x01) << 2;
-    val |= (m_psmpCapability & 0x01) << 4;
-    val |= (m_spsmpSupport & 0x01) << 6;
-    val |= (m_event & 0x01) << 7;
-    return val;
-}
-
-void
-ExtendedCapabilities::SetExtendedCapabilitiesByte2(uint8_t ctrl)
-{
-    m_diagnostics = ctrl & 0x01;
-    m_multicastDiagnostics = (ctrl >> 1) & 0x01;
-    m_locationTracking = (ctrl >> 2) & 0x01;
-    m_fms = (ctrl >> 3) & 0x01;
-    m_proxyArpService = (ctrl >> 4) & 0x01;
-    m_collocatedInterferenceReporting = (ctrl >> 5) & 0x01;
-    m_civicLocation = (ctrl >> 6) & 0x01;
-    m_geospatialLocation = (ctrl >> 7) & 0x01;
-}
-
-uint8_t
-ExtendedCapabilities::GetExtendedCapabilitiesByte2() const
-{
-    uint8_t val = 0;
-    val |= m_diagnostics & 0x01;
-    val |= (m_multicastDiagnostics & 0x01) << 1;
-    val |= (m_locationTracking & 0x01) << 2;
-    val |= (m_fms & 0x01) << 3;
-    val |= (m_proxyArpService & 0x01) << 4;
-    val |= (m_collocatedInterferenceReporting & 0x01) << 5;
-    val |= (m_civicLocation & 0x01) << 6;
-    val |= (m_geospatialLocation & 0x01) << 7;
-    return val;
-}
-
-void
-ExtendedCapabilities::SetExtendedCapabilitiesByte3(uint8_t ctrl)
-{
-    m_tfs = ctrl & 0x01;
-    m_wnmSleepMode = (ctrl >> 1) & 0x01;
-    m_timBroadcast = (ctrl >> 2) & 0x01;
-    m_bssTransition = (ctrl >> 3) & 0x01;
-    m_qosTrafficCapability = (ctrl >> 4) & 0x01;
-    m_acStationCount = (ctrl >> 5) & 0x01;
-    m_multipleBssid = (ctrl >> 6) & 0x01;
-    m_timingMeasurement = (ctrl >> 7) & 0x01;
-}
-
-uint8_t
-ExtendedCapabilities::GetExtendedCapabilitiesByte3() const
-{
-    uint8_t val = 0;
-    val |= m_tfs & 0x01;
-    val |= (m_wnmSleepMode & 0x01) << 1;
-    val |= (m_timBroadcast & 0x01) << 2;
-    val |= (m_bssTransition & 0x01) << 3;
-    val |= (m_qosTrafficCapability & 0x01) << 4;
-    val |= (m_acStationCount & 0x01) << 5;
-    val |= (m_multipleBssid & 0x01) << 6;
-    val |= (m_timingMeasurement & 0x01) << 7;
-    return val;
-}
-
-void
-ExtendedCapabilities::SetExtendedCapabilitiesByte4(uint8_t ctrl)
-{
-    m_channelUsage = ctrl & 0x01;
-    m_ssidList = (ctrl >> 1) & 0x01;
-    m_dms = (ctrl >> 2) & 0x01;
-    m_utcTsfOffset = (ctrl >> 3) & 0x01;
-    m_tpuBufferStaSupport = (ctrl >> 4) & 0x01;
-    m_tdlsPeerPsmSupport = (ctrl >> 5) & 0x01;
-    m_tdlsChannelSwitching = (ctrl >> 6) & 0x01;
-    m_interworking = (ctrl >> 7) & 0x01;
-}
-
-uint8_t
-ExtendedCapabilities::GetExtendedCapabilitiesByte4() const
-{
-    uint8_t val = 0;
-    val |= m_channelUsage & 0x01;
-    val |= (m_ssidList & 0x01) << 1;
-    val |= (m_dms & 0x01) << 2;
-    val |= (m_utcTsfOffset & 0x01) << 3;
-    val |= (m_tpuBufferStaSupport & 0x01) << 4;
-    val |= (m_tdlsPeerPsmSupport & 0x01) << 5;
-    val |= (m_tdlsChannelSwitching & 0x01) << 6;
-    val |= (m_interworking & 0x01) << 7;
-    return val;
-}
-
-void
-ExtendedCapabilities::SetExtendedCapabilitiesByte5(uint8_t ctrl)
-{
-    m_qosMap = ctrl & 0x01;
-    m_ebr = (ctrl >> 1) & 0x01;
-    m_sspnInterface = (ctrl >> 2) & 0x01;
-    m_msgcfCapability = (ctrl >> 4) & 0x01;
-    m_tdlsSupport = (ctrl >> 5) & 0x01;
-    m_tdlsProhibited = (ctrl >> 6) & 0x01;
-    m_tdlsChannelSwitchingProhibited = (ctrl >> 7) & 0x01;
-}
-
-uint8_t
-ExtendedCapabilities::GetExtendedCapabilitiesByte5() const
-{
-    uint8_t val = 0;
-    val |= m_qosMap & 0x01;
-    val |= (m_ebr & 0x01) << 1;
-    val |= (m_sspnInterface & 0x01) << 2;
-    val |= (m_msgcfCapability & 0x01) << 4;
-    val |= (m_tdlsSupport & 0x01) << 5;
-    val |= (m_tdlsProhibited & 0x01) << 6;
-    val |= (m_tdlsChannelSwitchingProhibited & 0x01) << 7;
-    return val;
-}
-
-void
-ExtendedCapabilities::SetExtendedCapabilitiesByte6(uint8_t ctrl)
-{
-    m_rejectUnadmittedFrame = ctrl & 0x01;
-    m_serviceIntervalGranularity = (ctrl >> 1) & 0x07;
-    m_identifierLocation = (ctrl >> 4) & 0x01;
-    m_uapsdCoexistence = (ctrl >> 5) & 0x01;
-    m_wnmNotification = (ctrl >> 6) & 0x01;
-    m_qabCapability = (ctrl >> 7) & 0x01;
-}
-
-uint8_t
-ExtendedCapabilities::GetExtendedCapabilitiesByte6() const
-{
-    uint8_t val = 0;
-    val |= m_rejectUnadmittedFrame & 0x01;
-    val |= (m_serviceIntervalGranularity & 0x07) << 1;
-    val |= (m_identifierLocation & 0x01) << 4;
-    val |= (m_uapsdCoexistence & 0x01) << 5;
-    val |= (m_wnmNotification & 0x01) << 6;
-    val |= (m_qabCapability & 0x01) << 7;
-    return val;
-}
-
-void
-ExtendedCapabilities::SetExtendedCapabilitiesByte7(uint8_t ctrl)
-{
-    m_utf8Ssid = ctrl & 0x01;
-    m_qmfActivated = (ctrl >> 1) & 0x01;
-    m_qmfReconfigurationActivated = (ctrl >> 2) & 0x01;
-    m_robustAvStreaming = (ctrl >> 3) & 0x01;
-    m_advancedGcr = (ctrl >> 4) & 0x01;
-    m_meshGcr = (ctrl >> 5) & 0x01;
-    m_scs = (ctrl >> 6) & 0x01;
-    m_qloadReport = (ctrl >> 7) & 0x01;
-}
-
-uint8_t
-ExtendedCapabilities::GetExtendedCapabilitiesByte7() const
-{
-    uint8_t val = 0;
-    val |= m_utf8Ssid & 0x01;
-    val |= (m_qmfActivated & 0x01) << 1;
-    val |= (m_qmfReconfigurationActivated & 0x01) << 2;
-    val |= (m_robustAvStreaming & 0x01) << 3;
-    val |= (m_advancedGcr & 0x01) << 4;
-    val |= (m_meshGcr & 0x01) << 5;
-    val |= (m_scs & 0x01) << 6;
-    val |= (m_qloadReport & 0x01) << 7;
-    return val;
-}
-
-void
-ExtendedCapabilities::SetExtendedCapabilitiesByte8(uint8_t ctrl)
-{
-    m_alternateEdca = ctrl & 0x01;
-    m_unprotectedTxopNegotiation = (ctrl >> 1) & 0x01;
-    m_protectedTxopNegotiation = (ctrl >> 2) & 0x01;
-    m_protectedQloadReport = (ctrl >> 3) & 0x01;
-    m_tdlsWiderBandwidth = (ctrl >> 4) & 0x01;
-    m_operatingModeNotification = (ctrl >> 5) & 0x01;
-    m_maxNumberOfMsdusInAmsdu = (ctrl >> 6) & 0x03;
-}
-
-uint8_t
-ExtendedCapabilities::GetExtendedCapabilitiesByte8() const
-{
-    uint8_t val = 0;
-    val |= m_alternateEdca & 0x01;
-    val |= (m_unprotectedTxopNegotiation & 0x01) << 1;
-    val |= (m_protectedTxopNegotiation & 0x01) << 2;
-    val |= (m_protectedQloadReport & 0x01) << 3;
-    val |= (m_tdlsWiderBandwidth & 0x01) << 4;
-    val |= (m_operatingModeNotification & 0x01) << 5;
-    val |= (m_maxNumberOfMsdusInAmsdu & 0x03) << 6;
-    return val;
-}
-
-void
 ExtendedCapabilities::SerializeInformationField(Buffer::Iterator start) const
 {
-    // write the corresponding value for each bit
-    start.WriteU8(GetExtendedCapabilitiesByte1());
-    start.WriteU8(GetExtendedCapabilitiesByte2());
-    start.WriteU8(GetExtendedCapabilitiesByte3());
-    start.WriteU8(GetExtendedCapabilitiesByte4());
-    start.WriteU8(GetExtendedCapabilitiesByte5());
-    start.WriteU8(GetExtendedCapabilitiesByte6());
-    start.WriteU8(GetExtendedCapabilitiesByte7());
-    start.WriteU8(GetExtendedCapabilitiesByte8());
+    uint8_t byte = 0;
+    byte |= m_20_40_bssCoexistenceManagementSupport & 0x01;
+    byte |= (m_extendedChannelSwitching & 0x01) << 2;
+    byte |= (m_psmpCapability & 0x01) << 4;
+    byte |= (m_spsmpSupport & 0x01) << 6;
+    byte |= (m_event & 0x01) << 7;
+    start.WriteU8(byte);
+
+    byte = 0;
+    byte |= m_diagnostics & 0x01;
+    byte |= (m_multicastDiagnostics & 0x01) << 1;
+    byte |= (m_locationTracking & 0x01) << 2;
+    byte |= (m_fms & 0x01) << 3;
+    byte |= (m_proxyArpService & 0x01) << 4;
+    byte |= (m_collocatedInterferenceReporting & 0x01) << 5;
+    byte |= (m_civicLocation & 0x01) << 6;
+    byte |= (m_geospatialLocation & 0x01) << 7;
+    start.WriteU8(byte);
+
+    byte = 0;
+    byte |= m_tfs & 0x01;
+    byte |= (m_wnmSleepMode & 0x01) << 1;
+    byte |= (m_timBroadcast & 0x01) << 2;
+    byte |= (m_bssTransition & 0x01) << 3;
+    byte |= (m_qosTrafficCapability & 0x01) << 4;
+    byte |= (m_acStationCount & 0x01) << 5;
+    byte |= (m_multipleBssid & 0x01) << 6;
+    byte |= (m_timingMeasurement & 0x01) << 7;
+    start.WriteU8(byte);
+
+    byte = 0;
+    byte |= m_channelUsage & 0x01;
+    byte |= (m_ssidList & 0x01) << 1;
+    byte |= (m_dms & 0x01) << 2;
+    byte |= (m_utcTsfOffset & 0x01) << 3;
+    byte |= (m_tpuBufferStaSupport & 0x01) << 4;
+    byte |= (m_tdlsPeerPsmSupport & 0x01) << 5;
+    byte |= (m_tdlsChannelSwitching & 0x01) << 6;
+    byte |= (m_interworking & 0x01) << 7;
+    start.WriteU8(byte);
+
+    byte = 0;
+    byte |= m_qosMap & 0x01;
+    byte |= (m_ebr & 0x01) << 1;
+    byte |= (m_sspnInterface & 0x01) << 2;
+    byte |= (m_msgcfCapability & 0x01) << 4;
+    byte |= (m_tdlsSupport & 0x01) << 5;
+    byte |= (m_tdlsProhibited & 0x01) << 6;
+    byte |= (m_tdlsChannelSwitchingProhibited & 0x01) << 7;
+    start.WriteU8(byte);
+
+    byte = 0;
+    byte |= m_rejectUnadmittedFrame & 0x01;
+    byte |= (m_serviceIntervalGranularity & 0x07) << 1;
+    byte |= (m_identifierLocation & 0x01) << 4;
+    byte |= (m_uapsdCoexistence & 0x01) << 5;
+    byte |= (m_wnmNotification & 0x01) << 6;
+    byte |= (m_qabCapability & 0x01) << 7;
+    start.WriteU8(byte);
+
+    byte = 0;
+    byte |= m_utf8Ssid & 0x01;
+    byte |= (m_qmfActivated & 0x01) << 1;
+    byte |= (m_qmfReconfigurationActivated & 0x01) << 2;
+    byte |= (m_robustAvStreaming & 0x01) << 3;
+    byte |= (m_advancedGcr & 0x01) << 4;
+    byte |= (m_meshGcr & 0x01) << 5;
+    byte |= (m_scs & 0x01) << 6;
+    byte |= (m_qloadReport & 0x01) << 7;
+    start.WriteU8(byte);
+
+    byte = 0;
+    byte |= m_alternateEdca & 0x01;
+    byte |= (m_unprotectedTxopNegotiation & 0x01) << 1;
+    byte |= (m_protectedTxopNegotiation & 0x01) << 2;
+    byte |= (m_protectedQloadReport & 0x01) << 3;
+    byte |= (m_tdlsWiderBandwidth & 0x01) << 4;
+    byte |= (m_operatingModeNotification & 0x01) << 5;
+    byte |= (m_maxNumberOfMsdusInAmsdu & 0x03) << 6;
+    start.WriteU8(byte);
 }
 
 uint16_t
 ExtendedCapabilities::DeserializeInformationField(Buffer::Iterator start, uint16_t length)
 {
     Buffer::Iterator i = start;
-    uint8_t byte1 = i.ReadU8();
-    uint8_t byte2 = i.ReadU8();
-    uint8_t byte3 = i.ReadU8();
-    uint8_t byte4 = i.ReadU8();
-    uint8_t byte5 = i.ReadU8();
-    uint8_t byte6 = i.ReadU8();
-    uint8_t byte7 = i.ReadU8();
-    uint8_t byte8 = i.ReadU8();
-    SetExtendedCapabilitiesByte1(byte1);
-    SetExtendedCapabilitiesByte2(byte2);
-    SetExtendedCapabilitiesByte3(byte3);
-    SetExtendedCapabilitiesByte4(byte4);
-    SetExtendedCapabilitiesByte5(byte5);
-    SetExtendedCapabilitiesByte6(byte6);
-    SetExtendedCapabilitiesByte7(byte7);
-    SetExtendedCapabilitiesByte8(byte8);
+
+    auto byte = i.ReadU8();
+    m_20_40_bssCoexistenceManagementSupport = byte & 0x01;
+    m_extendedChannelSwitching = (byte >> 2) & 0x01;
+    m_psmpCapability = (byte >> 4) & 0x01;
+    m_spsmpSupport = (byte >> 6) & 0x01;
+    m_event = (byte >> 7) & 0x01;
+
+    byte = i.ReadU8();
+    m_diagnostics = byte & 0x01;
+    m_multicastDiagnostics = (byte >> 1) & 0x01;
+    m_locationTracking = (byte >> 2) & 0x01;
+    m_fms = (byte >> 3) & 0x01;
+    m_proxyArpService = (byte >> 4) & 0x01;
+    m_collocatedInterferenceReporting = (byte >> 5) & 0x01;
+    m_civicLocation = (byte >> 6) & 0x01;
+    m_geospatialLocation = (byte >> 7) & 0x01;
+
+    byte = i.ReadU8();
+    m_tfs = byte & 0x01;
+    m_wnmSleepMode = (byte >> 1) & 0x01;
+    m_timBroadcast = (byte >> 2) & 0x01;
+    m_bssTransition = (byte >> 3) & 0x01;
+    m_qosTrafficCapability = (byte >> 4) & 0x01;
+    m_acStationCount = (byte >> 5) & 0x01;
+    m_multipleBssid = (byte >> 6) & 0x01;
+    m_timingMeasurement = (byte >> 7) & 0x01;
+
+    byte = i.ReadU8();
+    m_channelUsage = byte & 0x01;
+    m_ssidList = (byte >> 1) & 0x01;
+    m_dms = (byte >> 2) & 0x01;
+    m_utcTsfOffset = (byte >> 3) & 0x01;
+    m_tpuBufferStaSupport = (byte >> 4) & 0x01;
+    m_tdlsPeerPsmSupport = (byte >> 5) & 0x01;
+    m_tdlsChannelSwitching = (byte >> 6) & 0x01;
+    m_interworking = (byte >> 7) & 0x01;
+
+    byte = i.ReadU8();
+    m_qosMap = byte & 0x01;
+    m_ebr = (byte >> 1) & 0x01;
+    m_sspnInterface = (byte >> 2) & 0x01;
+    m_msgcfCapability = (byte >> 4) & 0x01;
+    m_tdlsSupport = (byte >> 5) & 0x01;
+    m_tdlsProhibited = (byte >> 6) & 0x01;
+    m_tdlsChannelSwitchingProhibited = (byte >> 7) & 0x01;
+
+    byte = i.ReadU8();
+    m_rejectUnadmittedFrame = byte & 0x01;
+    m_serviceIntervalGranularity = (byte >> 1) & 0x07;
+    m_identifierLocation = (byte >> 4) & 0x01;
+    m_uapsdCoexistence = (byte >> 5) & 0x01;
+    m_wnmNotification = (byte >> 6) & 0x01;
+    m_qabCapability = (byte >> 7) & 0x01;
+
+    byte = i.ReadU8();
+    m_utf8Ssid = byte & 0x01;
+    m_qmfActivated = (byte >> 1) & 0x01;
+    m_qmfReconfigurationActivated = (byte >> 2) & 0x01;
+    m_robustAvStreaming = (byte >> 3) & 0x01;
+    m_advancedGcr = (byte >> 4) & 0x01;
+    m_meshGcr = (byte >> 5) & 0x01;
+    m_scs = (byte >> 6) & 0x01;
+    m_qloadReport = (byte >> 7) & 0x01;
+
+    byte = i.ReadU8();
+    m_alternateEdca = byte & 0x01;
+    m_unprotectedTxopNegotiation = (byte >> 1) & 0x01;
+    m_protectedTxopNegotiation = (byte >> 2) & 0x01;
+    m_protectedQloadReport = (byte >> 3) & 0x01;
+    m_tdlsWiderBandwidth = (byte >> 4) & 0x01;
+    m_operatingModeNotification = (byte >> 5) & 0x01;
+    m_maxNumberOfMsdusInAmsdu = (byte >> 6) & 0x03;
+
     return length;
 }
 
